#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#define SEED 35791246

typedef struct 
{
	double x;
	double y;
}Point;

typedef struct 
{
	Point center;
	int radius;
}Circle;

Point randomPoint(double d)
{
	Point p;
	p.x =(double)rand()/RAND_MAX;
	p.y=(double)rand()/RAND_MAX;
	return p;
}

double distance(Point p1, Point p2)
{
	return sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y));
}

int inCircle(Circle c,Point p)
{
	return distance(c.center, p) <= c.radius;
}



int main()
{
	int niter=0;
	double pi;
	int count=0;
	int i=0;
	Circle c={{1,1},1};
	Point p;
	srand(SEED);
	printf("Enter the number of iterations used to estimate pi: ");
	scanf("%d",&niter);
	for(i=0;i<niter;i++)
	{
		p=randomPoint(2.0);
		if(inCircle(c,p))
			count++;
	}
	pi =4.0*count/niter;
	printf("# of trials= %d , estimate of pi is %g \n",niter,pi);
	return 0;
}

