#include <stdio.h>
#include <math.h>
#include <string.h>
enum BOOLEAN {True=1, False=0};

typedef struct 
{
	double x;
	double y;
        char name[20];
	
}Point;

typedef struct
{
	Point leftBottom;
	Point rightTop;
        char name[20];
}Rect;

double computeDistance(Point p1, Point p2)
{
	return sqrt(p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y);
}


BOOLEAN  equalPoint(Point p1, Point p2)
{
	return 	computeDistance(p1,p2) < 1e-5 ? True : False;
}

void printPoint(Point p1)
{
	printf("Point  %s: %f %f \n",p1.name,p1.x,p1.y);
}


double rectArea( Rect r)
{
 	return (r.rightTop.x-r.leftBottom.x)*(r.rightTop.y-r.leftBottom.y);
}

void printRectangle(Rect r)
{
	printf("Rectangle %s \n",r.name);
	printPoint(r.leftBottom);
	printPoint(r.rightTop);
}

BOOLEAN pointIsInsideRect(Point P, Rect r)
{
	return P.x < r.rightTop.x && P.x > r.leftBottom.x && P.y <r.rightTop.y && P.y > r.leftBottom.y ?  True : False;
}

BOOLEAN rectInsideRect(Rect R1, Rect R2)
{
	BOOLEAN b1=pointIsInsideRect(R1.leftBottom,R2);
	BOOLEAN b2=pointIsInsideRect(R1.rightTop,R2);
	return b1==True && b2 == True ? True : False;
}

int main()
{

	Point p1={2.0,3,"p1"};
	Point p2={5,7,"p2"};
	Point testPoint[2];
	testPoint[0].x=1;
	testPoint[0].y=4;
	strcpy(testPoint[0].name,"testPoint0");
	testPoint[1].x=3;
	testPoint[1].y=4;
	strcpy(testPoint[1].name,"testPoint1");

	Point p3={3,4,"p3"};
	Point p4={4,6,"p4"};
	Rect r2={p3,p4,"rectangle2"};
	Rect r={p1,p2,"rectangle3"};
	printPoint(p1);
	printPoint(p2);
	printf("Equal? %s \n",equalPoint(p1,p2)==False ? "false":"true");

	for(int i=0;i<2;i++)
	{	
		printPoint(testPoint[i]);
		printRectangle(r);
		printf("Point inside rectangle? %s\n", pointIsInsideRect(testPoint[i],r)==False ? "false":"true");

	}
	printRectangle(r2);
	printRectangle(r);
	printf("%s is inside %s ? %s\n", r2.name,r.name,rectInsideRect(r2,r) == False ? "false":"true");
	

	return 0;
}

